const { env } = require('process')

// Log results at the end
const logStatus = function ({ modifiedHeaders, injectedScripts: { successes, failures } }) {
  if (env.DPC_TEST === 'true') {
    return
  }

  if (nothingChanged({ modifiedHeaders, successes, failures })) {
    console.log('No HTML pages to inject the <script> tag')
    return
  }

  modifiedHeaders.forEach(logModifiedHeader)
  logScriptSuccess(successes)
  failures.forEach(logScriptFailure)
}

const nothingChanged = function ({ modifiedHeaders, successes, failures }) {
  return modifiedHeaders.length === 0 && successes.length === 0 && failures.length === 0
}

const logModifiedHeader = function ({ filePath, updatedContents }) {
  console.log(`Rewrote ${filePath} to:

${updatedContents}
`)
}

const logScriptSuccess = function (successes) {
  if (successes.length === 0) {
    return
  }

  console.log(`Injected the <script> tag into ${successes.length} HTML pages`)
}

const logScriptFailure = function ({ filePath, error }) {
  console.error(`Could not inject the <script> tag into ${filePath}:
${error.stack}`)
}

module.exports = {
  logStatus,
}
